#include <cstdlib>
#include <iostream>

using namespace std;

int main(int argc, char *argv[])
{
/*
V programe vytvorme textov sbor s nzvom myfile.txt, ktor bude umiestnen
na disku d v adresari egt - ak tento adresr pred spustenm programu
ete nemme, musme ho manulne vytvori. Do tohto sboru zapeme
nejak reazce(vety), zatvorme ho, znova otvorme a pretame do
naej premennej v programe a tto nsledne vypeme na obrazovku
*/

// Premenn typu sbor. *fp zna, e to nie je priamo premenn, ale
// umiestnenie (miesto v pamti), kde sa tto premenn nachdza
FILE *fp;
/*
Do sborovej premennej fp ulome informciu o sbore, s ktorm ideme
pracova a to tak, e tento sbor otvorme funkciou open, ktor poaduje
ako prv argument nzov sboru a druh argument - reazec urujci,
o chceme so sborom robi. V tomto prpade "w"(write) zna, e
do sboru chceme zapisova (vklada) dta, informcie
*/
fp = fopen("d:/egt/myfile.txt", "w");
if(fp == false){ // Ak po otvoren sboru m premenn fp hodnotu false
   // zna to, e nieo nie je v poriadku a sbor nevieme otvori.
   // Preto tto informciu vypeme uvateovi na obrazovku,
   printf("Error opening file\n");
   system("PAUSE");   // pokme, km nestla klves a
   exit(1);           // ukonme program
};
/*
Ak sa program dostal a sem, zna to, e sa nm sbor popdarilo
spene otvori pre zapisovanie a meme do neho vklada informcie.
Urobme to funkciou fprintf, ktor je analogick s klasickou
funkciou printf pre vypisovanie na obrazovku. Na rozdiel od funkcie
printf, funkcia fprintf m navye prv argument (fp - premenn sboru, do
ktorho ide zapisova)
*/

fprintf(fp, "%s", "Nad Tatrou sa blyska\n"); // Za kadou vetou zariadkujeme
fprintf(fp, "%s", "hromy divo biju.\n");
fprintf(fp, "%s", "Zastavme ich bratia,\n");
fprintf(fp, "%s", "ved sa ony stratia,\n");
fprintf(fp, "%s", "Slovaci oziju.\n");
fclose(fp); // Zatvorme sbor. Vykonanm funkcie fclose, operan
// systm ete zape do sboru informcie, ktor sme do neho chceli
// zapsa a z nejakho dvodu ete neboli zapsan. Do sboru
// u nebudeme mc zapisova a do prpadnho optovnho volania
// funkcie fopen.

/*
Avak sborov premenn teraz meme poui na otvorenie toho
istho sboru ale nie pre zapisovanie do neho ale pre tanie
informci z neho. Pokojne by sme vak mohli poui aj aliu
premenn typu sbor, napr.
FILE *gp;
*/
fp = fopen("d:/egt/myfile.txt", "r");  // Sbor otvrame s prznakom r(read)
if (fp == false){  // Op testovanie, i sme boli spen
   printf("Error opening file\n");
   system("PAUSE");
   exit(1);
};

// Dobre, sbor sa nm podarilo otvori na tanie
// Zadefinujeme si premenn typu reazec (pole znakov) s kapacitou
// 200 znakov
char s[200];
/*
Funkcia fgets je analgiou funkcie gets, ktor preta reazec
(vetu, text) z klvesnice. Na rozdiel od funkcie gets, m funkcia
fgets navye druh argument (dka reazcovej premennej) a tret
argument (sborov premenn sboru, z ktorho chceme preta
informciu)

Teraz na rozdiel od lekcie 025 pretame a vypeme jednotliv riadky
vyie vytvorenho sboru na obrazovku - tentokrt vak takm spsobom,
ktor bude nezvisl od potu riadkov vo vstupnom (tanom) sbore
*/

// Zo vstupnho sboru tame riadky pokm nenarazmme na
// koniec sboru (end of file) - nie je iadny riadok - v tomto
// prpade funkcia fgets vrti hodnotu 0 
while(fgets(s, 200, fp) != 0)
   printf("%s", s);  // Vypis precitany riadok na obrazovku
   
// Vybaven, cel sbor je vypsan pomocou dvoch riadkov programovho
// kdu vyie, bez ohadu na to, koko riadkov dt sbor obsahuje
fclose(fp);          // Zatvor sbor

/*
LOHA1: skste pri vytvran textovho sboru vynecha vo formtovacom
reazci funkcie fprintf znaky \n, spustite program a zistite, o sa stane.

LOHA2: vstupn sbor vytvorte rune s inm textom (v Notepade++,
resp. v Notepade, vymate alebo odkomentujte t as programu, v ktorej
sa vytvra(zapisuje) sbor a vypte riadky sboru na obrazovku
*/ 

printf(" \n\n\n K O N I E C . \n\n");
system("PAUSE");
}
