#include <cstdlib>
#include <iostream>

using namespace std;

/*
Funkcia je alm fundamentlnym pojmom v programovan.
Je to vlastne as programu, ktor m hlaviku a telo.
Hlavicka obsahuje typ funkcie, meno funkcie a v ztvorkch
zoznam parametrov (argumentov) funkcie. V tele funkcie sa
nachdza kd (intrukcie) funkcie.
Funcie sa v programe vyuvaj hlavne na eliminciu opakovanch
intrukci v programe. Napr. scanf a printf s tie funkcie.
*/ 

// Defincie dvoch funkcii

// Logick (vracia true alebo false) funkcia s nzvom parne
// a jednm celoselnm argumentom slo. Tto fukcia zist,
// i argument cislo je parny. Ak ano "vrti" do programu, ktor
// ju "volal" hodnotu true, in vrti hodnotu false

bool parne(int cislo){
  if(cislo%2 == 0)    // Argument funkcie je deliten dvomi ?
    return true;      // no, poli programu, ktor a "volal"
    // hodnotu true a "od" z funkcie do volajceho programu 
    // hne za "volanie funkcie v hlavnom programe
  else      // tu vieme, ze argument fukcie (premenn cislo)
    // nie je deliten dvomi, vr hodnotu false
    return false;
};


// Celoseln (vrti cel slo) funkcia  vykon nad operandami,
// ktorch hodnoty s v argumentoch o1 s o2 operciu, ktorej
// znak sa nachdza v argumente oper

int operacia(char oper, int o1, int o2){
int vysledok;     // Premenn, kam prde vsledok opercie
switch(oper){
    case '+':         // Znamienko opercie je + ?
      vysledok=o1+o2; // no, vykonaj scitanie
      break;   // prejdi za koniec prkazu switch
    case '-':         // Znamienko opercie je - ?
      vysledok=o1-o2; // no, vykonaj odtanie
      break;   // prejdi za koniec prkazu switch
    case '*':         // Znamienko opercie je krt ?
      vysledok=o1*o2; // no, vykonaj sin
      break;   // prejdi za koniec prkazu switch
    case '/':         // Znamienko opercie je lomeno ?
      vysledok=o1/o2; // no, vykonaj delenie
      break;   // prejdi za koniec prkazu switch                                  
    default:
      // uvate vloil nesprvnu operciu. Pozna
      // to do premennej vsledok. 
      vysledok=1000000;
      break;                         
};       // Koniec prkazu switch
return vysledok;   // Odovzdanie vsledku do volajceho programu
};

// Koniec definci funkci

int main(int argc, char *argv[]) // Hlavn funkcia
{

int m;
int n;
bool b;

m=56;

// "Volme" funkciu parne s argumentom - premennou m (t.j. hodnotou 56)
b=parne(m);

// Vyp vsledok fukcie (vypsan 0 bude znai false, 1 true)
printf(" \n%d\n", b );

// "Volme" funkciu operacia s argumentami - +, m, 100. Ako argument
// meme zada bu premenn (m), alebo kontantu-slo (100)
n=operacia('+', m, 100);

// Vyp vsledok funkcie (vypsan 0 bude znai false, 1 true) 
printf(" \n%d\n\n", n );

// Sksime zavola funkciu operacia s inmi argumentami
n=operacia('*', 100, 200);

// Vyp vsledok
printf(" \n%d\n\n", n );

/*
Vidme, e namiesto viacnsobnho psania siahodlhho programovho
kdu:
----------------------------------------------------------     
switch(oper){
    case '+':         // Znamienko opercie je + ?
      vysledok=o1+o2; // no, vykonaj scitanie
      break;   // prejdi za koniec prkazu switch
    case '-':         // Znamienko opercie je - ?
      vysledok=o1-o2; // no, vykonaj odtanie
      break;   // prejdi za koniec prkazu switch
    case '*':         // Znamienko opercie je krt ?
      vysledok=o1*o2; // no, vykonaj sin
      break;   // prejdi za koniec prkazu switch
    case '/':         // Znamienko opercie je lomeno ?
      vysledok=o1/o2; // no, vykonaj delenie
      break;   // prejdi za koniec prkazu switch                                  
    default:
      // uvate vloil nesprvnu operciu. Pozna
      // to do premennej vsledok. 
      vysledok=1000000;
      break;                         
};       // Koniec prkazu switch
--------------------------------------------------------------
sta prkaz v jednom riadku:
n=operacia('*', 100, 200);       
*/

/*
LOHA: napte a nsledne pouite v programe funkciu

bool samohlaska(char hlaska)

ktor vrti hodnotu true, ak znak v argumente hlaska je samohlaska.
Ak nie, vrti hodnotu false. Na zistenie, i je znak samohlska,
pouite prkaz switch:

switch(hlaska){
    case 'a': case 'e': ... at
*/
   
printf("\n\n\n");
system("PAUSE");   
}
