#include <cstdlib>
#include <iostream>

using namespace std;

int main(int argc, char *argv[])
{
/*
V programe vytvorme textov sbor s nzvom myfile.txt, ktor bude umiestnen
na disku d v adresari egt - ak tento adresr pred spustenm programu
ete nemme, musme ho manulne vytvori. Do tohto sboru zapeme
nejak reazce(vety), zatvorme ho, znova otvorme a pretame do
naej premennej v programe a tto nsledne vypeme na obrazovku
*/

// Premenn typu sbor. *fp zna, e to nie je priamo premenn, ale
// umiestnenie (miesto v pamti), kde sa tto premenn nachdza
FILE *fp;
/*
Do sborovej premennej fp ulome informciu o sbore, s ktorm ideme
pracova a to tak, e tento sbor otvorme funkciou open, ktor poaduje
ako prv argument nzov sboru a druh argument - reazec urujci,
o chceme so sborom robi. V tomto prpade "w"(write) zna, e
do sboru chceme zapisova (vklada) dta, informcie
*/
fp = fopen("d:/egt/myfile.txt", "w");
if(fp == false){ // Ak po otvoren sboru m premenn fp hodnotu false
   // zna to, e nieo nie je v poriadku a sbor nevieme otvori.
   // Preto tto informciu vypeme uvateovi na obrazovku,
   printf("Error opening file\n");
   system("PAUSE");   // pokme, km nestla klves a
   exit(1);           // ukonme program
};
/*
Ak sa program dostal a sem, zna to, e sa nm sbor popdarilo
spene otvori pre zapisovanie a meme do neho vklada informcie.
Urobme to funkciou fprintf, ktor je analogick s klasickou
funkciou printf pre vypisovanie na obrazovku. Na rozdiel od funkcie
printf, funkcia fprintf m navye prv argument (fp - premenn sboru, do
ktorho ide zapisova)
*/

fprintf(fp, "%s", "Nad Tatrou sa blyska\n");
fprintf(fp, "%s", "hromy divo biju.");
fclose(fp); // Zatvorme sbor. Vykonanm funkcie fclose, operan
// systm ete zape do sboru informcie, ktor sme do neho chceli
// zapsa a z nejakho dvodu ete neboli zapsan. Do sboru
// u nebudeme mc zapisova a do prpadnho optovnho volania
// funkcie fopen.

/*
Avak sborov premenn teraz meme poui na otvorenie toho
istho sboru ale nie pre zapisovanie do neho ale pre tanie
informci z neho. Pokojne by sme vak mohli poui aj aliu
premenn typu sbor, napr.
FILE *gp;
*/
fp = fopen("d:/egt/myfile.txt", "r");  // Sbor otvrame s prznakom r(read)
if (fp == false){  // Op testovanie, i sme boli spen
   printf("Error opening file\n");
   system("PAUSE");
   exit(1);
};

// Dobre, sbor sa nm podarilo otvori na tanie
// Zadefinujeme si premenn typu reazec (pole znakov) s kapacitou
// 200 znakov
char s[200];
/*
Funkcia fgets je analgoiu funkcie gets, ktor preta reazec
(vetu, text) z klvesnice. Na rozdiel od funkcie gets, n funkcia
fgets navye druh argument (dka reazcovej premennej) a tret
argument (sborov premenn sboru, z ktorho chceme preta
informciu)
Do reazcovej premennej s pretaj prv riadok sboru
*/ 
fgets(s, 200, fp);
// Reazcov premenn s vyp na obrazovku pomocou starej dobrej
// funkcie  printf (formtovac znak %s zna, e vypisujeme reazec)
printf("%s", s);
fgets(s, 200, fp);   // Pretaj druh riadok zo sboru
printf("%s\n\n", s); // Vyp, pridaj aj riadkovanie
fclose(fp);      // Zatvor sbor

/*
LOHA1: vyskajte program so sborom s inm menom a v inom adresri
(nezabudnite v programe upravi zmenen informcie o sbore)

LOHA2: do sboru vlote nejak vety manulne (pomocou Notepadu++,
alebo Notepadu), intrukcie pre zapisovanie do sboru vymate
(alebo okomentujte), nezabudnite prissobi poet prkazov
tania zo sboru a nslednho vpisu na obrazovku a skste,
o sa bude dia

LOHA3: to ist o loha2, len teraz vymate (okomentujte) tanie
a vpis na obrazovku zo sboru - sbor skontrolujte manulne v Notepade.

*/ 
printf(" \n\n\n K O N I E C . \n\n");
system("PAUSE");
}
